// AForge.NET Framework
// Motion Detection sample application
//
// Copyright  Andrew Kirillov, 2007
// andrew.kirillov@gmail.com
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using AForge.Video.DirectShow;

namespace AForge.Video.Local
{
    public partial class VideoCaptureDeviceForm : Form
    {
        FilterInfoCollection videoDevices;

        private string videoDeviceMoniker;

        // Video device moniker
        public string VideoDeviceMoniker
        {
            get { return videoDeviceMoniker; }
        }

        private string videoDeviceName;

        // Video device name
        public string VideoDeviceName
        {
            get { return videoDeviceName; }
        }

        // Constructor
        public VideoCaptureDeviceForm( )
        {
            InitializeComponent( );

            // show device list
			try
			{
                // enumerate video devices
                videoDevices = new FilterInfoCollection( FilterCategory.VideoInputDevice );

                if ( videoDevices.Count == 0 )
                    throw new ApplicationException( );

                // add all devices to combo
                foreach ( FilterInfo device in videoDevices )
                {
                    devicesCombo.Items.Add( device.Name );
                }
            }
            catch ( ApplicationException )
            {
                devicesCombo.Items.Add( "No local capture devices" );
                devicesCombo.Enabled = false;
                okButton.Enabled = false;
            }

            devicesCombo.SelectedIndex = 0;
        }

        // Ok button clicked
        private void okButton_Click( object sender, EventArgs e )
        {
            FilterInfo selectedVideoDevice = videoDevices[devicesCombo.SelectedIndex];
            videoDeviceMoniker = selectedVideoDevice.MonikerString;
            videoDeviceName = selectedVideoDevice.Name;
        }
    }
}